=== config/CMakeLists.txt ===
if(WIN32)
	set(QUTIM_CONFIG_DIR config)
	add_subdirectory(win)
elseif(APPLE)
	set(QUTIM_CONFIG_DIR ${QUTIM_BUNDLE_NAME}/Contents/Resources/config)
	add_subdirectory(mac)
elseif(MAEMO5)
	set(QUTIM_CONFIG_DIR share/qutim/config)
	add_subdirectory(maemo5)
else()
	set(QUTIM_CONFIG_DIR share/qutim/config)
	add_subdirectory(generic)
endif()
