=== config/win/CMakeLists.txt ===
install(FILES 
	profile.json 
	appearance.json 
	DESTINATION ${QUTIM_CONFIG_DIR}
)
