=== plugins/antiboss/CMakeLists.txt ===
qutim_add_plugin( antiboss
	DISPLAY_NAME "Anti-boss plugin"
	DESCRIPTION "Plugin makes your chatting invisible for boss"
)
