=== plugins/awn/CMakeLists.txt ===
qutim_add_plugin( awn
	DISPLAY_NAME "AWN"
	DESCRIPTION "Avant window navigator dock integration"
	QT_LIBRARIES DBUS
)
