=== plugins/blogimprover/CMakeLists.txt ===
qutim_add_plugin( blogimprover
	DISPLAY_NAME "BlogImprover plugin"
	DESCRIPTION "Integration with different services of microblogging"
)
